"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const common_2 = require("@pardjs/common");
const auth_service_common_1 = require("@pardjs/auth-service-common");
const constants_1 = require("./constants");
const service_1 = require("./service");
const childLogger = common_2.logger.child({ service: 'dynamic-roles-guard' });
let AirRolesGuard = class AirRolesGuard {
    constructor(service) {
        this.service = service;
        if (!this.service && constants_1.PARDJS_AUTH_SERVICE_BASE_URL) {
            this.service = new service_1.PardjsUsersService();
        }
    }
    canActivate(context) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!constants_1.PARDJS_AUTH_SERVICE_BASE_URL) {
                if (constants_1.GREEN_LIGHT_WITHOUT_USER_SERVICE) {
                    return true;
                }
                else {
                    childLogger.error('no auth-service connected, reject by default.');
                    return false;
                }
            }
            const request = context.switchToHttp().getRequest();
            if (!request.headers) {
                request.headers = {};
            }
            const token = common_2.fromAnywhere()(request);
            const authPointName = Reflect.getMetadata(auth_service_common_1.AuthPointNameKey, context.getHandler());
            common_2.logger.info('authPointName in AirRolesGuard', { authPointName });
            const user = yield this.service.canAccess(token, authPointName);
            request.user = user;
            return true;
        });
    }
};
AirRolesGuard = __decorate([
    common_1.Injectable()
], AirRolesGuard);
exports.AirRolesGuard = AirRolesGuard;
//# sourceMappingURL=air-roles.guard.js.map